var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import * as _ from 'lodash';
import { Component, ViewChild, Input, Renderer } from "@angular/core";
import { ModalContainerDirective } from "./modal.directive";
import { DocumentRef } from "../document-ref";
let ModalComponent = class ModalComponent {
    constructor(doc, renderer) {
        this.doc = doc;
        this.renderer = renderer;
        this.onModalClick = ($event) => {
            if (this.backdropCloseable && document.contains($event.target)) {
                this.hide();
            }
        };
        this.backdropCloseable = _.isUndefined(this.backdropCloseable) ? true : this.backdropCloseable;
    }
    onHidden() { }
    canHideModel() {
        let hiddenResult = Promise.resolve(true);
        if (this.beforeHidden) {
            const result = this.beforeHidden();
            if (typeof result !== undefined) {
                if (result.then) {
                    hiddenResult = result;
                }
                else if (result.subscribe) {
                    hiddenResult = result.toPromise();
                }
                else {
                    hiddenResult = Promise.resolve(result);
                }
            }
        }
        return hiddenResult;
    }
    hide() {
        this.canHideModel().then((canHide) => {
            if (!canHide) {
                return;
            }
            this.renderer.setElementClass(this.doc.body, 'modal-open', false);
        });
    }
    show() {
        this.renderer.setElementClass(this.doc.body, 'modal-open', true);
    }
};
__decorate([
    ViewChild(ModalContainerDirective),
    __metadata("design:type", ModalContainerDirective)
], ModalComponent.prototype, "modalContainerHost", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], ModalComponent.prototype, "id", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], ModalComponent.prototype, "width", void 0);
__decorate([
    Input(),
    __metadata("design:type", Boolean)
], ModalComponent.prototype, "backdropCloseable", void 0);
__decorate([
    Input(),
    __metadata("design:type", Function)
], ModalComponent.prototype, "beforeHidden", void 0);
ModalComponent = __decorate([
    Component({
        selector: 'dc-modal',
        template: `<div>modal</div><template dcModalContainerHost></template>`,
        styles: ['']
    }),
    __metadata("design:paramtypes", [DocumentRef, Renderer])
], ModalComponent);
export { ModalComponent };
//# sourceMappingURL=modal.component.js.map