var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import * as _ from 'lodash';
import { Injectable, ComponentFactoryResolver, Injector, ApplicationRef } from "@angular/core";
import { DocumentRef } from "../document-ref";
import { ModalComponent } from "./modal.component";
let ModalService = class ModalService {
    constructor(cfr, appRef, doc, injector) {
        this.cfr = cfr;
        this.appRef = appRef;
        this.doc = doc;
        this.injector = injector;
    }
    insert(viewRef) {
        this.appRef.attachView(viewRef);
        this.doc.body.appendChild(viewRef.rootNodes[0]);
        return viewRef;
    }
    createComponent(cf) {
        const componentRef = cf.create(this.injector);
        this.insert(componentRef.hostView);
        return componentRef;
    }
    open({ id, component, width, data, handler, backdropCloseable, onClose, beforeHidden }) {
        const modalRef = this.createComponent(this.cfr.resolveComponentFactory(ModalComponent));
        _.assign(modalRef.instance, { id, width, beforeHidden, backdropCloseable: _.isUndefined(backdropCloseable) ? true : backdropCloseable });
        const modalContentInstance = modalRef.instance.modalContainerHost.viewContainerRef.createComponent(this.cfr.resolveComponentFactory(component));
        _.assign(modalContentInstance.instance, { data, handler });
        modalRef.instance.onHidden = () => {
            if (onClose) {
                onClose();
            }
            modalRef.hostView.destroy();
        };
        modalRef.instance.show();
        return {
            modalInstance: modalRef.instance,
            modalContentInstance: modalContentInstance.instance
        };
    }
};
ModalService = __decorate([
    Injectable(),
    __metadata("design:paramtypes", [ComponentFactoryResolver,
        ApplicationRef,
        DocumentRef,
        Injector])
], ModalService);
export { ModalService };
//# sourceMappingURL=modal.service.js.map